#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"

int main(){
	/*
	center_count : count of center postion
	target_post  : post number selected by post_select()
		"post number" means seaquencial number of posts found in post_search()
	target_code  : IRS code of the post to get now
		This variable is defined as gloabl varialble.
	*/
	int center_count=0;
	int center_corr_count=0;
	int target_post=0;
	int ret;
	int search_retry, search_result=-1;
	int i=0;
	char a;
	int orz=0;

	FILE *fp;		//post_data
	FILE *fplog_ct;		//log control_test.c
	FILE *fpe;		//error
	FILE *fplog_ps0;
	FILE *fplog_fc;		//log function.c change
	FILE *fplog_pa;

	fp=fopen("post_data.txt","a+");
	fplog_ct=fopen("log_control_test.txt","w");
	fpe=fopen("error.txt","w");
	fplog_ps0=fopen("log_post_search_0.txt","w");	/*log post_search_0.c*/
	fplog_fc=fopen("log_function_change.txt","w");

	fplog_pa=fopen("log_post_approach_prototype1.txt","w");


	post.got_number=0;

	printf("Initialize\n");
	ret=initialize();

//ưƥ
	printf("type 1 ~ 5\n");
	a = getchar();

	switch(a){
		case '1':
			printf("a = %c\n",a);
			printf("normal mode\n");
			usleep(300000);		//wait 0.5sec

			break;
		case '2':
			printf("a = %c\n",a);
			printf("skip first post search\n");
			usleep(300000);		//wait 0.5sec

			goto TEST1;
			break;
		case '3':
			printf("a = %c\n",a);
			printf("skip center move\n");
			usleep(300000);		//wait 0.5sec

			goto POST_SH;
			break;
		case '4':
			printf("a = %c\n",a);
			printf("post search 3~ start\n");
			usleep(300000);		//wait 0.5sec

			goto TEST2;
			break;
		case '5':
			printf("a = %c\n",a);
//			printf("set status:\n\n   post.ang[0]=120;\n   post.ang[1]=270;\n");
//			printf("   post.dis[0]=300;\n   post.dis[1]=500;\n   post.number=2;\n\n");
			usleep(300000);		//wait 0.5sec

			post.ang[1]=45;
			post.dis[1]=707;
			post.ang[2]=90;
			post.dis[2]=500;
			post.ang[3]=135;
			post.dis[3]=1200;

			goto TEST1;
			break;
		case '6':
			printf("arm_move start\n");
			arm_move();
			sleep(5);
			goto END;
			break;
		default:
			printf("error\n");
			usleep(300000);		//wait 0.5sec

			goto END;
			break;
	}

//\(^o^)/:add
	while(fscanf(fp,"Post No[%d]  Angle=%d  Distance=%d\n",&i,&post.ang[i],&post.dis[i]) != EOF){
		printf("post.ang[%d] = %d\n",i-1,post.ang[i-1]);
		printf("post.dis[%d] = %d\n",i-1,post.dis[i-1]);
	}
	if(i!=0){
		orz=1;
		goto OTL;
	}
//orz
	while(1){
		if(ts[0] == '1'){
			break;
		}else{
			usleep(20000);
		}
	}
//====================ư=====================
	pthread_create(&uss_task, &attr_uss, &uss_read, (void *)1);

	printf("### Post search 1stTry ###\n");
	usleep(100000);
/*ݥõ*/
	post_search_0();
	usleep(50000);
	printf("Searched post number =%d\n",post.number);
	/*̤˸ľ ®ǤɤȻפ*/
	lqr_rotate(-180,1000);
	fprintf(fplog_ps0,"Right rotation beginning.\n");

	fprintf(fplog_ct,"The first post search was ended.\n");
	fclose(fplog_ct);
	fplog_ct=fopen("log_control_test.txt","a");

	fprintf(fplog_ct,"Post check start\n");
	printf("### Post check start ###\n");
	if(post.number >= POST_NUM){
	/*ݥȥå*/
		post_check(1);
		printf("Searched post number after post_check=%d\n",post.number);
	}
	center_count++;

//	pthread_cancel(uss_task);

//	pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);
//	usleep(200000);

	printf("### Post select start ###\n");
	target_post = post_select(center_count);
	printf("Next post is %d\n",target_post);

	printf("### Approach target_post ###\n");
	post_approach(target_post);


	target_code=post.got_code+1;

//test
	mapping(0);
//

	printf("### Post get start ###\n");
	post_get(target_post);

	printf("target_post = %d",target_post);
	fprintf(fplog_ct,"target_post = %d",target_post);
	fclose(fplog_ct); fplog_ct=fopen("log_control_test.txt","a");

	printf("### Move start point ###\n");
	move_center(target_post);

	pthread_cancel(uss_task);
	usleep(40000);
//	goto END;			/*ƥ*/
//====================ưλ=====================

TEST1:
	change();	//The post data is converted
	printf("### The post data is converted. ###\n");
	mapping(0);

OTL:
	printf("### Move to center ###\n");
	fprintf(fplog_ct,"Move to center\n");
	//lqr_straight(1450,6000);
	lqr_straight(1000,3000);	//ذư

POST_SH:

	printf("POST_NUM= %d  post.got_number= %d\n",POST_NUM, post.got_number);
	if(post.got_number==POST_NUM) goto END;
//\(^o^)/:add
	if(orz=1) goto OTL2;
//orz
	center_count++;
	center_corr_count++;


	usleep(300000);

	pthread_create(&uss_task, &attr_uss, &uss_read, (void *)1);


	printf("Post search 2nd Try\n");

	if(center_count==1){
		fprintf(fplog_ct,"post search 2 start\n");
		printf("Searched post number =%d\n",post.number);
		while(post.number!=POST_NUM){
	 		usleep(300000);
			post_search(center_count);
			printf("Searched post number =%d\n",post.number);
			if(post.number >= POST_NUM){
				post_check(center_count);
				printf("Searched post number after post_check=%d\n",post.number);
			}
		}
	}
	for(i=0;i<post.number;i++){
			printf("post.ang[%d]=%d  post.dis[%d]=%d\n",i,post.ang[i],i,post.dis[i]);
	}

	//exit(0);

TEST2:

	if(center_corr_count>2){
		printf("Searched post number =%d\n",post_tmp.number);
		fprintf(fplog_ct,"post search 3~ start\n");
		search_retry=0;
		search_result=0;
		while(post_tmp.number!=POST_NUM){
        		usleep(300000);
			if(search_retry>=1){		/*ݥȤդʤäΥȥ饤1*/
				search_result=-1;
				break;
			}
			post_search(center_count);
			printf("Searched post number =%d\n",post_tmp.number);
			if(post.number >= POST_NUM){
				post_check(center_count);
			}
			search_retry++;
		}
	}
        usleep(300000);
/*											
	if(center_corr_count>2 && search_result==0) {
		center_corr_count=0; 
		printf("Move to correct center position\n");
		//printf("dis1=%d dis2=%d ang1=%d ang2=%d\n",post.dis[0],post.dis[1],post.ang[0],post.ang[1]);
		//printf("dis1_=%d dis2_=%d ang1_=%d ang2_=%d\n",post_tmp.dis[0],post_tmp.dis[1],post_tmp.ang[0],post_tmp.ang[1]);
		correct_center();
	}
*/
	pthread_cancel(uss_task);

OTL2:

        pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);

        usleep(300000);

/////////////////////Τؤ󤫤Ϯ/////////////////////

/*
	target_post = post_select(center_count);		//䡧٤ݥȤ򡡤
	printf("Next post is %d\n",target_post);
*/

/* ɲ			//å(¾)ɤ߼곫ϡ㳰ư ɬפʤ餷orz
	pthread_create(&ts_task, &attr_ts, &irs_ts_ws, (void *)1);
*/

	printf("Approach target_post\n");
	post_approach(target_post);

/*		ɤ߼꽪λɬפʤΤ
	pthread_cancel(ts_task);
*/

/*
	target_code=post.got_code+1;			//䡧ݥֹβû
*/


	printf("Post get start\n");
	post_get(target_post);

	//exit(0);

/* 濴ˡޤϥݥȯǤ褦ˤʤ͢ */
	printf("Move center\n");
	move_center(target_post);

///ɲ///
	target_post++;						/*û㤦(ܸ)*/

	pthread_cancel(uss_task2);

	//exit(0);

	goto POST_SH;

END:

	usleep(300000);
	pwm_both_data(0,0);
	usleep(400000);
	pwm_enco_stop();
	usleep(400000);
	printf("All posts have been got\n");
	printf("Original Post postion\n");
	fprintf(fp,"Original Post postion\n");
	for(i=0;i<post.number;i++){
		printf("Post No[%d]  Angle=%d  Distance=%d\n",i,post.ang[i],post.dis[i]);
		fprintf(fp,"Post No[%d]  Angle=%d  Distance=%d\n",i,post.ang[i],post.dis[i]);
	}
	printf("Tempral Post postion\n");
	for(i=0;i<post.number;i++){
		printf("Post No[%d]  Angle=%d  Distance=%d\n",i,post_tmp.ang[i],post_tmp.dis[i]);
		fprintf(fp,"Post No[%d]  Angle=%d  Distance=%d\n",i,post_tmp.ang[i],post_tmp.dis[i]);
	}

	// close all device file 
        close(fd0);
        close(fd1);
        close(fd2);
        close(fd3);
        //close(fd4);
        close(fd5);
        //close(fd6);
        //close(fd7);
        close(ctl);
        fclose(fp);
	fclose(fplog_ct);
	fclose(fplog_ps0);
	fclose(fpe);
	fclose(fplog_fc);
	fclose(fplog_pa);
	return 0;
}
