/*
	Functions used in control program

	post_select:
		Select next post to which MIRS approah 
	irs_code_get: 
		Get IRS code
	uss_get:
		Get USS data (one shot task)
	correct_direction1: this is renewed one
		Correct direction before approach the target post.
	correct_direction2: this is renewed one
		Correct direction after approach the target post.
	move_center:
		Move to center postion after post_get mode
	lqr_rotate:
		Macro of rotaion in LQR mode;
	lqr_straght:
		Macro of straight movement in LQR mode;
	lqr_circle:
		Macro of going around a post in LQR mode;
	get_num:
		Get post number;
	change:
		Angle data is angling of seeing from a center position converted;
	arm_move:
		;
	
*/
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include <math.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"

//addition by 0804 for get_num
#define BACK_TS	3	/*back TS number*/
#define KURO	'0'	/*responce of WS when WS find black line*/
#define GET_TIME 50000	/*time of get responce of WS*/
#define CHECK_LOOP 50	/*loop count for check of WS*/
#define LQR_DEG	180	/*degree of rotate 180[deg] for lqr_rotate*/
#define RORT_TIME 3600	/*time of rotate 180[deg] for lqr_rotate*/
//addition for mapping
#define STD_LENG 3600		/*The total length of stadium [mm] Τ礭*/
#define EDGE_TO_WLINE 150	/*Length from edge to white line [mm] 狼ޤǤεΥ*/
#define WLINE_WIDTH 50		/*White line width [mm] */
#define POST_TO_POST 450	/*Distance between posts [mm] ݥȴ֤κǾΥ*/
#define POST_DIA 200		/*Diameter of post [mm] ݥȥ*/
#define MOVED_DIS 1000.0	/*濴ޤǤΰưΥ(¿ʬcontrol.hۤɤȻפ)*/
#define MIRS_SIZE 940		/*MIRSΥߥ⡼ɻĹ() 340300ȤƷ׻*/
#define pi 3.141592

int post_select(int center_count){

	int dis_min;
	int i;
	int next_post_num=-1;
	int next_post_code;

	dis_min=2000; 
	next_post_code=post.got_code+1;

	printf("post.got_code=%d post_number=%d\n",post.got_code,post.number);

	for(i=0;i<post.number;i++){
		printf("i=%d dis=%d ang=%d code=%d got=%d\n",i,post.dis[i],post.ang[i],post.code[i],post.got_post[i]);
	}

	printf("center_count=%d  next_post_code=%d dis_min=%d\n",center_count,next_post_code,dis_min);

	if(center_count==1){
		for(i=0;i<post.number;i++){
			printf("i=%d post.dis=%d dis_min=%d\n",i,post.dis[i],dis_min); 
			if(post.dis[i]<dis_min){
				dis_min=post.dis[i];
				next_post_num=i;
			}
		}
		return next_post_num;
	}

	if(center_count>1){
		for(i=0;i<post.number;i++){
			if(post.code[i]==next_post_code){
				return i;
			}
		}
		for(i=0;i<post.number;i++){
			if(post.code[i]==0 && post.dis[i]<dis_min){
				dis_min=post.dis[i];
				next_post_num=i;
			}
		}
		return next_post_num;
	}

	return -1;
}

/*
int irs_code_get(int dumy){

	int irs_select;
	int irs_get_code=0;
	char code_char='0';
	irs_select = dumy;

	fd6=open("/dev/irs_code",O_RDWR);
	write(fd6,&irs_select,sizeof(int));
        usleep(10000);
	read(fd6,&code_char,sizeof(char));
	close(fd6);
	fd6=open("/dev/irs_code",O_RDWR);
        usleep(100000);
	read(fd6,&code_char,sizeof(char));

	if(code_char=='1') {irs_get_code=1; goto NEXT;}
	if(code_char=='2') {irs_get_code=2; goto NEXT;}
	if(code_char=='3') {irs_get_code=3; goto NEXT;}
	if(code_char=='4') {irs_get_code=4; goto NEXT;}
	if(code_char=='5') {irs_get_code=5; goto NEXT;}
	if(code_char=='6') {irs_get_code=6; goto NEXT;}
NEXT:
        usleep(100000);
	close(fd6);

	printf("irs_get_code=%d\n",irs_get_code);

	return irs_get_code;
}
*/

int uss_get(int uss_no){

	uss_msg.command=1; /* 1 Shot Task */
	uss_msg.number = uss_no;
	write(ctl, &uss_msg, sizeof(uss_msg));

	usleep(30000);
	printf("uss_data %d\n",uss_data);
	return uss_data;
}

int correct_direction1(int target_post){	/**/
	int uss1,uss2;
	int maxdif;
	int r_value = 0;
	int r_count = 0;

	printf("correct_direction1 function start\n");

	maxdif=12;	/*١1012ˤ*/
	cor_ang=0;
	
	while(1){
	NSS1:
		//renew the uss data
		uss1=uss_get(1);
		usleep(20000);
		uss2=uss_get(2);
		usleep(20000);
		uss12=(uss1+uss2)/2;

		//uss1 == 9999 || uss2 == 9999 is included in the if-block
		if(uss1>USS_MAX && uss2>USS_MAX){
			printf("USS ERROR!\n");
			r_count++;
			//when if-block is called, the post does not exist.
			if(r_count == 30){	/*30ܤΥ顼ȯ*/
				printf("post does not exist.\n");
				r_value = -1;
				break;
			}else{//uss_error
				printf("uss errer_count = %d\n",r_count);
				goto NSS1;
			}
		}
		if( uss1>USS_MAX ){	/*1֤顼λΤ򱦲ž*/
			r_count = 0; /*clear uss_error count*/
			cor_ang+=lqr_rotate(-23,1000);	/*εΥθangle-20-23ѹ*/
			goto NSS1;
		}
		if( uss2>USS_MAX ){	/*2֤顼λΤ򺸲ž*/
			r_count = 0;
			cor_ang+=lqr_rotate(23,1000);	/*1֤λƱ͡2023ѹ*/
			goto NSS1;
		}

		if(abs(uss1-uss2-USS12_DIFF)<=maxdif){
			r_value = 1; 
			break;
		}
		if(uss1-USS12_DIFF > uss2) {
			r_count = 0;
//			cor_ang+=lqr_rotate(-13,1000);
			cor_ang+=lqr_rotate(-12,900);	/*٤p*/
			goto NSS1;
		} 
		if(uss2+USS12_DIFF > uss1) {
			r_count = 0;
//			cor_ang+=lqr_rotate(15,1000);
			cor_ang+=lqr_rotate(14,900);	/*٤p*/
			goto NSS1;
		}
	}

	printf("uss1=%d uss2=%d\n",uss1,uss2);
	printf("correct_direction1 func end.\n");
	// If you wish to redefine post angle and distance,
	// remove comment-out in next line. 
	//post.ang[target_post]+=angle;
	//post.dis[target_post]=(uss1+uss2)/2 - uss_dis[is]+USS_CORRECT+MCENTER_USS3_DIS+post_diameter/2;
	return r_value;
}

int correct_direction2(int target_post){
	int uss1,uss2;

	printf("correct_direction2 function start\n");
	while(1){
		NSS1:	
		uss1=uss_get(1);
		usleep(20000);
		uss2=uss_get(2);
		usleep(20000);
		if( uss1 == 9999 || uss2 == 9999){
			printf("USS ERROR\n");
			goto NSS1;
		}

		if(abs(uss1-uss2+USS12_DIFF)<=10){
		 	break;
		}
		if(uss1+USS12_DIFF > uss2){
			//lqr_rotate(-12,1000); 
			lqr_rotate(-12,300); 
		} 
		else {
			//lqr_rotate(16,1000);  
			lqr_rotate(16,300);  
		}
		usleep(100000);
	}
	printf("uss1=%d uss2=%d\n",uss1,uss2);
	printf("correct_direction2 func end.\n");
	return 0; 
} 

int move_center(int target_post){

	int move_time;
	int rotate_time;
	int angle;
	int distance;

	lqr_rotate(90,1800);
	
	//correct direction2 
	correct_direction2(target_post);

	usleep(500000);
	printf("return_dist=%d\n",return_dist);
	distance=-return_dist;
	move_time=distance*4;
	lqr_straight(distance,move_time);
	usleep(500000);

	if(post.ang[target_post]<180){
		//angle= 180-post.ang[target_post];
		angle= -post.ang[target_post];
	}else{
		//angle= -(post.ang[target_post]-180);
		angle= 360-post.ang[target_post];
	}
	rotate_time=angle*20;
	lqr_rotate(angle,rotate_time);
	usleep(500000);		//1000000 -> 500000
	
	return 0;
}

int lqr_rotate(int ang,int time){

	int angle=0;
	pwm_enco_start(10);
	usleep(40000);
	pwm_lqr_rotate(ang,abs(time));
	usleep(40000);
        count.br=0;
        while(1){
                if(count.br==1) break;
                usleep(20000);
        }
	angle=180*diameter*count.left_sum/(dist_ct*cpr*gear);
	pwm_both_data(0,0);
	usleep(40000);
	pwm_enco_stop();
	return angle;
}

int lqr_straight(int dis,int time){

	pwm_enco_start(10);
	usleep(40000);
	pwm_lqr_straight(dis,abs(time));
	usleep(40000);
        count.br=0;
        while(1){
                if(count.br==1) break;
                usleep(20000);
        }
	pwm_both_data(0,0);
	usleep(40000);
	pwm_enco_stop();
	return 0;
}

int lqr_circle(int radious,int ang,int time){

	pwm_enco_start(10);
	usleep(40000);
	pwm_lqr_circle(radious,ang,abs(time));
	usleep(40000);
        count.br=0;
        while(1){
                if(count.br==1) break;
                usleep(20000);
        }
	pwm_both_data(0,0);
	usleep(40000);
	pwm_enco_stop();
	return 0;
}

int get_num(void)
{
/***************************************************************************************/
//090206 12:50 get_num ver2.91

	int post_num=0;	/*ݥֹ*/
	int i,j,k=0;		/*Ƚ˻Ѥ륫*/
	char get_post='e';	/*顼Ф˻*/
	char got_ws[4];	/*󥵤ͤ*/
	int ts_search=0;	/*å󥵤դʤб*/

	printf("\nstart moving");

	//03:14
	/*straight200[mm]->turnleft180[deg]->back50[mm]*/
	printf("\n straight_200[mm],1000[msec]\n");
	lqr_straight(200,1000);
	usleep(300000);
	usleep(1000000);
	printf("\n turnright_185[deg],3600[msec]\n");
	lqr_rotate(-LQR_DEG,RORT_TIME);
	usleep(300000);
	usleep(RORT_TIME*1000);
	pwm_both_data(0,0);
	pwm_enco_start(10);
	usleep(20000);
	printf("\n back_100[mm],800[msec]\n");
	pwm_lqr_straight(-100,2000);
	count.br=0;
	//ưλե饰

	i=0;
	j=0;
	/*touch_sensorcheck*/
	while(count.br==0){
		usleep(20000);
		if(ts[BACK_TS]=='1'){
			usleep(300000);
			//tire stop
			pwm_both_data(0,0);
			usleep(20000);
			//stop encoder task
			printf("\n Stop encoder task.\n");
			pwm_enco_stop();
			usleep(20000);
			break;
		}
		if(count.br==1 && ts_search!=7) {
			//tire stop
			pwm_both_data(0,0);
			usleep(20000);
			pwm_enco_stop();
			usleep(20000);
			printf("\n***********TS was not detected.***********\n\n");
			pwm_both_data(0,0);
			pwm_enco_start(10);
			usleep(20000);
			switch(ts_search){
				case 0:
					ts_search=1;
					i=20;
					pwm_lqr_rotate(20,300);
					usleep(20000);
					count.br=0;
					break;
				case 1:
					ts_search=2;
					j=-10;
					pwm_lqr_straight(-10,100);
					usleep(20000);
					count.br=0;
					break;
				case 2:
					ts_search=3;
					i=i-10;
					pwm_lqr_rotate(-10,100);
					usleep(20000);
					count.br=0;
					break;
				case 3:
					ts_search=4;
					i=i+20;
					pwm_lqr_rotate(20,300);
					usleep(20000);
					count.br=0;
				case 4:
					ts_search=5;
					j=j-10;
					pwm_lqr_straight(-10,100);
					usleep(20000);
					count.br=0;
				case 5:
					ts_search=6;
					i=i-10;
					pwm_lqr_rotate(-10,150);
					usleep(20000);
					count.br=0;
				case 6:
					k=CHECK_LOOP+1;
					ts_search=7;
					j=j-10;
					pwm_lqr_straight(-10,150);
					usleep(20000);
					count.br=0;
			}
			if(count.br==1 && ts_search==7){
				//tire stop
				pwm_both_data(0,0);
				usleep(20000);
				pwm_enco_stop();
				usleep(20000);
				break;
			}
		}	
	}

	pwm_lqr_rotate(-i,i*20);
	usleep(600000);

	pwm_lqr_straight(j,j*4);
	usleep(150000);

	i=0;
	j=0;


/*
psition of white sensor
     POST
|||||||||||||||
|             |no signal:post number=1
|||||||||||||||
|             |>ws[3]:post number=2
|||||||||||||||
|             |>ws[2]:post number=3
|||||||||||||||
|             |>ws[1]:post number=4
|||||||||||||||
|             |>ws[0]:post number=5
|||||||||||||||
|||||||||||||||
*/

/*Ƚμ
1.ws[3]ͤ򻲾ȤơϤդ֤겼
wsդƤ鳺ݥֹȤ롣
Ϥդ֤겼wsդʤ
Х顼
CHECK_LOOPޤǥȥ饤롣
2.1ǥݥֹǤʤä硢־Τߤǥݥ
ֹȽǤ롣
ȽǤֹ椬˥ݥȹ¤ΤcodeϿƤȤ
Ԥ롣
3.1,2ǥݥֹǤʤä硢ݥȹ¤ΤcodeϿ
ƤʤݥֹPOST_NUM֤˳Ƥ롣

1ǥݥֹǤ硢ֹο٤trust_level1Ȥ
롣Ʊͤˡ2,3ǥݥֹϡtrust_level2,3
롣٤trust_level1>2>3νǹ⤤
ݥֹ椬ΤȽʣ硢trust_level
⤤ΤȽǤݥȤֹˤ̤ΤΤ
Ƥ롣ǳƤ줿ֹο٤trust_level3Ȥ롣
*/

//*Ƚʬ======================
	printf("\n start get num\n");
	while(get_post=='e' && k<=CHECK_LOOP){
	printf("level1_start\n");
	printf("\n\nnow_%dnd_loop\n\n",k);
	//errorȤCHECK_LOOPޤrepeat
		usleep(GET_TIME);
		//ͤι
		k++;
		//ʤȶΤǤ뤿counter
		get_post='n';
		//errorȽ
		for(i=0;i<=3;i++){got_ws[i]=ws[i];}
		//wsͤfix
		printf("level1_initialize\n");
		for(j=(POST_NUM-2);j>=0;j--){
			if(got_ws[j]!=KURO){
			//ws[j]=
				for(i=POST_NUM-2;i>=j+1;i--){
					if(got_ws[i]==KURO){
						get_post='e';
						printf("e.");
					}
					printf("\n");
					//ws[j]ʳ=error
				}
				if(get_post!='e' && trust_level[j+2]!=1){
					post_num=j+2;
					printf("post_num=%d\n",post_num);
				}
				//顼̵=j+2post
			}else{post_num=POST_NUM;}
			//wsƹ=POST_NUMpost
		}
	}

	if(post_num!=0 && trust_level[post_num]>=2){
	//ʣֹ潤
		printf("repairing_number\n");
		printf("pert 1\n");
		for(k=0;k<=POST_NUM;k++){
			if(post.code[k]==post_num){
				post.code[k]=0;
				break;
			}
		}
		printf("pert 2\n");
		i=POST_NUM+1;
		while(post.code[k]==0){
			i--;
			for(j=0;j<=post.got_number;j++){
				if(post.code[j]==i || post.code[j]==post_num){
					post.code[k]=0;
					j=POST_NUM;
				}else{
					post.code[k]=i;
				}
			}
		}
		trust_level[i]=3;
	}

	if(post_num=POST_NUM){
		trust_level[post_num]=3;
	}else{
		trust_level[post_num]=1;
	}
	//errorʤpost_get=level1
	//level1=max

	if(get_post!='e' && post_num!=0){
	//errorޤ޽λν
		printf("level2_start\n");
		if(got_ws[j]!=KURO){
			for(i=0;i<POST_NUM;i++){
				if(post.code[i]==j+2){break;}
				else if(trust_level[j+2]>2){post_num=j+2;}
			}
			//(ws[j]= and j+2post̤)=j+2post
		}else{
			for(i=0;i<POST_NUM;i++){
				if(post.code[i]==POST_NUM){break;}
				else if(trust_level[POST_NUM]>2){post_num=POST_NUM;}
			}
			//(ws= and POST_NUMpost̤)=POST_NUMpost
		}
		if(post_num!=0 && trust_level[post_num]>2){//ʣֹ潤
			printf("repairing_number\n");
			for(k=0;k<=POST_NUM;k++){
				if(post.code[k]==post_num){
					post.code[k]=0;
					break;
				}
			}
			i=POST_NUM+1;
			while(post.code[k]==0){
				i--;
				for(j=0;j<POST_NUM;j++){
					if(post.code[j]==i || post.code[j]==post_num){
						post.code[k]=0;
						j=POST_NUM;
					}else{
						post.code[k]=i;
					}
				}
			}
			trust_level[i]=3;
		}
		if(post_num=POST_NUM){
			trust_level[post_num]=3;
		}else if(post_num!=0){
			trust_level[post_num]=2;
			//level2=mid
		}
	}

	if(post_num==0){
		printf("level3_start\n");
		i=POST_NUM+1;
		while(post_num==0){
			i--;
			for(j=0;j<POST_NUM;j++){
				if(post.code[j]!=i){
					post_num=0;
					break;
				}else{post_num=i;}
			}
		}
		trust_level[post_num]=3;
	}

//ޤȽʬ=======================*/

	printf("\n--the post is seen by mirs--");
	printf("\n|||||||||||||||");
	printf("\n|             |");
	printf("\n|||||||||||||||");
	for(i=3;i>=0;i--){
		if(got_ws[i]==KURO){
			printf("\n|             |");
		}else{
			printf("\n|||||||||||||||");
		}
	printf("<= ws[%d]=%c",i,got_ws[i]);
	printf("\n|||||||||||||||");
	}
	printf("\n|||||||||||||||");
	printf("\n|||||||||||||||");
	printf("\n|||||||||||||||");
	printf("\npost number = %d",post_num);
	printf("\ntrust_level of got number is %d\n",trust_level[post_num]);
	printf("\nfinish get num\n");


	return post_num;
/***************************************************************************************/
}
//post angle change
int change(void){
	int i=3;
	int j;
	double now_ang;
	double now_dis;
	double next_dis;
	double next_ang;

	FILE *fplog_fc;
	fplog_fc=fopen("log_function_change.txt","a");

/*	ưå
	post.ang[1]=45;
	post.dis[1]=707;
	post.ang[2]=90;
	post.dis[2]=500;
	post.ang[3]=135;
	post.dis[3]=1200;
*/

	for(j=1;j<=i;j++){
		now_ang=(double)post.ang[j];
		now_dis=(double)post.dis[j];
		now_ang=now_ang*pi/180.0;
		printf("now_ang=%lf\n",now_ang);
//		next_ang=atan(tan(now_ang)-1000.0/(now_dis*cos(now_ang)));	/**/
		next_ang=atan2((now_dis)*sin(now_ang)-MOVED_DIS,(now_dis)*cos(now_ang));
		next_dis=now_dis*cos(now_ang)/cos(next_ang);
		next_ang=next_ang*180.0/pi;
		printf("next_ang=%lf\n",next_ang);

		(next_ang < 0) ? (next_ang+=180.0) : (next_ang-=180.0);
		/*󥵰ѹб*/

		post.ang[j]=(int)next_ang;
		post.dis[j]=(int)next_dis;
	}
	for(j=1;j<=i;j++){
		printf("post.ang[%d] = %d\n",j,post.ang[j]);
		fprintf(fplog_fc,"post.ang[%d] = %d\n",j,post.ang[j]);	
		printf("post.dis[%d] = %d\n",j,post.dis[j]);
		fprintf(fplog_fc,"post.dis[%d] = %d\n",j,post.dis[j]);
	}
	fclose(fplog_fc);
	return 0;
}

int arm_move(){
	char mtr_dat[3];
	char *receive_data=mtr_dat;
	char *send_data1="1",*send_data2="0";

	//Device File open
	if ((fd7 = open("/dev/mtr", O_RDWR)) < 0) {
		fprintf(stderr, "Error opening /dev/mtr\n");
		exit(1);
	}
	
	read(fd7,receive_data,2);	//Read data from PIC.
	if(receive_data[0] == '0'){
		//printf("Data from PIC is Low.\nSend a pulse to PIC...\n");
	}else{
		//printf("Data from PIC is High.\nCheck MTR_PORT from PIC!!\n");
		close(fd7);
		return -1;
	}
	write(fd7,send_data1,2);
	sleep(1);
	write(fd7,send_data2,2);
	printf("Send pulse to PIC...\n");
	
	while(1){
		close(fd7);
		fd7=open("/dev/mtr",O_RDWR);
		read(fd7,receive_data,2);
		if(receive_data[0] == '1') break;
		usleep(100000);
	}
	printf("Received pulse from PIC!!\n");
	close(fd7);
	return 0;
}

int mapping(int display){

	int field[36][36];	/* ޥå׺ [Y][X] */
				/* ȥ:0, :-1, ݥ:15 */
	int i, j, k;
	int post_x;
	int post_y;
	double ang;
	double dis;

	FILE *fpmap;
	fpmap=fopen("Battle_Field.txt","w");
	fclose(fpmap);
	fpmap=fopen("Battle_Field.txt","a");

	for(i = 0; i <= 35; i++){			/*ޥåԥѥݥȰ֥ǡ*/
		for(j = 0; j <= 35; j++){
			if(i == 0 || i == 35){		/*ǾȺǲι*/
				field[i][j] = (-1);
			}else if(j == 0 || j == 35){	/*캸üȱü*/
				field[i][j] = (-1);
			}else{
				field[i][j] = 0;
			}
		}
	}

	printf("Array variable initialization completion\n");	/*λǤ˥*/
/*ݥȰ֥ǡѴ*/
	for(i=0; i<=post.number; i++){
		if(post.ang[i]>180){	//angle: 180 ~ -180
			post.ang[i]-=180;
		}else{
			post.ang[i]+=180;
		}
		ang=(double)post.ang[i];
		ang=ang*pi/180.0;		/*饸ͤѴ*/
		dis=(double)post.dis[i];
		post_x=(int)(dis*cos(ang)+0.5);
		post_y=(int)(dis*sin(ang)+0.5);

		printf("post_x = %d	post_y = %d\n",post_x,post_y);

		post_x=(post_x+(STD_LENG/2)+0.5)/100;
		post_y=((STD_LENG/2)-post_y+0.5)/100;
		if(post_x >= 36 || post_y >=36){		/*ҡݥȤʤ*/
			printf("\npost number %d is error\n\n",i+1);
			k = -1;
		}else{
			field[post_y][post_x] = i+1;
			printf("post_x = %d	post_y = %d  After convert\n",post_x,post_y);
		}
	}
/*ޥåɽ*/
	for(i = 0; i <= 35; i++){
		for(j = 0; j <= 35; j++){
			if(field[i][j] == 0){
				fprintf(fpmap,"  ");
			}else if(field[i][j] == (-1)){
				fprintf(fpmap,"00");
			}else if(field[i][j] >=1){
				fprintf(fpmap,"1%d",field[i][j]);
			}
		}
		fprintf(fpmap,"\n");
	}
	fclose(fpmap);
	return 0;
}

int judg(double ang, double dis){		/*ݥȥǡοȽ*/

	int x,y;
	int range = 0;		/*ݥȥǡͭϰ*/
	int post_error = 0;	/*ͭϰϳΤȤ1*/

	double ang;	//angle
	double dis;	//distance
	double post_x;	//
	double post_y;	//

	printf("Post data judg started\n\n");

	range=(STD_LENG/2)-(POST_DIA/2)-450;	/*ĹȾʬ - α狼ݥȤޤǤκûΥ - ݥȤȾ*/

	if(ang > 180.0){	//angle: 180 ~ -180
		ang -= 180.0;	/*ѴĤǤ180٤餷ɸൡ̣*/
	}else{
		ang += 180.0;
	}
	ang=ang*pi/180.0;		/*饸ͤѴ*/
	post_x=(dis*cos(ang)+0.5);	/*x,yĹФ*/
	post_y=(dis*sin(ang)+0.5);

//	printf("post_x = %lf	post_y = %lf \n",post_x,post_y);

	x=abs((int)post_x+0.5);
	y=abs((int)post_y+0.5);

	printf("post_x = %d	post_y = %d \n",post_x,post_y);

	if(x > range || y > range){	/*Ƚʬ x⤷yrange礭ȤϡեΥݥȤǤ̵*/
		printf("\nThis is not post\n\n");
		post_error = 1;		/*post_searchͤϤpost¤Τؤν񤭹ߤ˻ߤ*/
	}
	return post_error;
}
