/*
	This program (post_get) is developed based on MIRS0401 program get1.c.

	post_get is developed by Shinji Ushimaru.
	get1.c was developed by T.Mano (member of MIRS0401)
	Function: post_get
	MIRS acts as follows in this function.
	1. Turn to 90 degree.
	2. Go arround post with detecting IRS signal.
	3. If find IRS signal, MIRS memorize IRS code number and gets the post.
	4. MIRS retuns to the start position of 1.
*/
//090206 08:30 post_get ver.1.7
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"

//DEFINE SENSORS
#define IRS_FRONT	0
#define IRS_LEFT	1

//DEFINE TIME&DIS&ANG
#define TURN_TIME	1300
#define DETECTING_TIME	14000
#define SLEEP_TIME	200000
#define PUSH_TIME	3000
#define IRS_SLEEP1	300000
#define IRS_SLEEP2	700000
#define PWM_SLEEP	20000
#define LOOP_SLEEP	1000

//OTHER DEFINE
#define RETRY_NUMBER	8

int post_get(int target_post){

	int get_code=0;
//	int code_check=0;

	//A[WĴߌ
	printf("back for arm\n");
	lqr_straight(-150,600);
	usleep(PWM_SLEEP);

	//A[WJ
	printf("arm open\n");
	arm_move();
	usleep(SLEEP_TIME);

	//exit(0);

	// Start encoder task with period of 10msec
	printf("Start encoder task.\n");
	pwm_both_data(0,0);
	pwm_enco_start(10);
	usleep(PWM_SLEEP);

	//ڋߊJn
	printf("approach target post\n");
	pwm_lqr_straight(500, 2000);
	usleep(PWM_SLEEP);

	count.br=0;

	//ڋߒ^b`ZTcheck
	while(count.br==0){
		usleep(20000);
		if(ts[0]!='0'){
			usleep(IRS_SLEEP1);
			//tire stop
			pwm_both_data(0,0);
			usleep(PWM_SLEEP);
			//stop encoder task
			printf("Stop encoder task.\n");
			pwm_enco_stop();
			usleep(PWM_SLEEP);
			break;
		}

		if(count.br==1) {
			//tire stop
			pwm_both_data(0,0);
			usleep(PWM_SLEEP);
			pwm_enco_stop();
			usleep(PWM_SLEEP);
			printf("\n***********TS was not detected.***********\n\n");
			break;
		}
	}

	//A[Ń|Xgl
	printf("getting post\n");
	usleep(SLEEP_TIME);
	arm_move();
	usleep(SLEEP_TIME);
/*	lqr_rotate(75,500);
	usleep(20000);
	lqr_rotate(-160,1000);
	usleep(20000);
	lqr_rotate(85,500);
	usleep(20000);
*/
	//A[[̈׌
	lqr_straight(-300,3000);
	usleep(SLEEP_TIME);
	sleep(3);

	//A[[
	printf("arm close\n");
	arm_move();
	usleep(SLEEP_TIME);


	//|Xgԍ̎擾
	get_code=get_num();
	if(get_code!=0){
		post.code[target_post]=get_code;
	}
	usleep(50000);
	//printf("ir_code=%d \n",ir_code);

	//090206 00:15
	//move_enterJnʒu܂ňړ
	lqr_straight(300,1500);
	usleep(SLEEP_TIME);

	lqr_rotate(180,3600);
	usleep(SLEEP_TIME);


	printf("\nGetting post was success!!!\n");
	post.got_number++;
	post.got_code=get_code;
	usleep(SLEEP_TIME);

	printf("returned to start_circle\n\n");
	printf("finished post_get().\n\n");

	return 0;
}
